# #############################################################################
# fprints.awk							17-03-1998 (ra)
# -----------------------------------------------------------------------------
# In der Funktion finger_prints() werden die charakteristischen Format-Merkmale
# der Mailinglist -Archive definiert. Es sind dies
#
# 	1. der START_MAIL_TRIGGER, d.h. das Zeichenmuster, mit dem der Beginn 
#          einer Mail im Mailinglist-Archiv angezeigt wird.
#	2. der END_HEADER_TRIGGER, d.h. das Zeichenmuster, das das Ende des
#	   Mailheaders anzeigt (i.d.R. eine Leerzeile) und
#	3. der IGNORE-TEXT_IN_SUBJECT, d.h. der Text, der in einigen Mailing-
#	   list in des Subject-Feld eingefuegt wird, um die Herkunftsliste
#	   anzuzeigen (was eine wirkliche Zumutung ist).
#	4. das LOGFILE_PATTERN, das anzeigt, welches Zeichenmuster die Namen
#          der Logdateien haben duerfen.
#
# Die Trigger werden in Listen (ARRAYs) eingetragen, deren Index der Name der
# zugehoerigen Mailinglist ist. Dieser Name muss in der Umgebungsvariablen 
# MLIST gespeichert sein.
#
# Die Zeichenketten EQUAL_SIGNS und DASHES, die bei der Charakterisierung der
# Trigger gelegentlich benutzt werden sind als LOKALE VARIABLEN abgelegt und 
# stehen ausserhalb der Funktion finger_prints() NICHT zur Verfuegung.
#
# -----------------------------------------------------------------------------
#
# Die Funktion finger_prints() kann zu beliebigen awk-Programmen hinzugefuegt
# werden. Dies geschieht dadurch, dass sie im gawk-Aufruf als ERSTE Datei ge-
# nannt wird. (Als erste deshalb, weil sich andere Teile des Gesamtprogramms
# auf die in dieser Funktion vorgenommenen Definitionen beziehen.
#
# Bspl.: gawk -f fprints.awk -f phase-1.awk
#
# Die Datei fprints.awk sollte dabei im aktuellen Arbeitsverzeichnis abgelegt
# sein. Andernfalls MUSS die Umgebungsvariable AWKPATH korrekt gesetzt sein 
# und (in UNIX-Notation) auf ein Verzeichnis verweisen, in der die Datei
# fprints.awk abgelegt ist.
#
# #############################################################################
# 

function finger_prints( 		EQUAL_SIGNS, DASHES ) {

   for( i=1; i<=80; i++ ) EQUAL_SIGNS = EQUAL_SIGNS "="
   for( i=1; i<=80; i++ ) DASHES = DASHES "-"

   # --- europa --------------------------------------------------------------

   START_MAIL_TRIGGER_ARRAY[ "europa" ]       = \
     "^From owner-europa .*[0-2]*[0-9]\:[0-5][0-9]\:[0-5][0-9] .*19[89][0-9]$"
   END_HEADER_TRIGGER_ARRAY[ "europa" ]       = "^ *$"
   IGNORE_TEXT_IN_SUBJECT_ARRAY[ "europa" ]   = ""
   LOGFILE_PATTERN_ARRAY[ "europa" ]          = "^europa\.log(19[89]|20[0-9])[0-9][01][0-9]$"

}
