##############################################################################
# PHASE-1.AWK                                                    06-07-97 (ra)
#                                                                20-07-97 (ra)
#                                                                13-01-98 (ra)
#								 17-03-98 (ra)
#								 26-04-98 (ra)
# ----------------------------------------------------------------------------
# Das Programm PHASE-1.AWK dient der Extraktion von Informationen aus Log-
# Dateien von Mailing-Lists.
# ----------------------------------------------------------------------------
##############################################################################

# ============================================================================
# === BEGIN-Block fuer spezifische, die Mailing-List betreffende Einstellungen
# ============================================================================

BEGIN {
  finger_prints()
}

# ============================================================================
# === Dateien & feststehende Trigger =========================================
# ============================================================================
BEGIN {

   if ( DB_FILE == "" ) DB_FILE = "mail.db"
   USER_FILE            = "user.dat"
   SUBJ_FILE            = "subj.dat"

   FROM_TRIGGER         = "^FROM:"
   SUBJ_TRIGGER         = "^SUBJECT:"
   DATE_TRIGGER         = "^DATE:"

   for( i=1; i<=80; i++ ) dashes = dashes "-"
}

# ============================================================================
# === Bestimmung der Mailing-Liste ===========================================
# ============================================================================

BEGIN {

   STDERR = "/dev/stderr"

   ROOT = ENVIRON[ "ROOT" ]
   gsub( "\\\\", "/", ROOT )

   MLIST = tolower( ENVIRON[ "MLIST" ] )
   if ( MLIST == "" )
   {  print "Keine Mailing-Liste in init.bat angegeben. - Programmabbruch." > STDERR
      exit
   }

   START_MAIL_TRIGGER     = START_MAIL_TRIGGER_ARRAY[ MLIST ]
   END_HEADER_TRIGGER     = END_HEADER_TRIGGER_ARRAY[ MLIST ]
   IGNORE_TEXT_IN_SUBJECT = IGNORE_TEXT_IN_SUBJECT_ARRAY[ MLIST ]
   LOGFILE_PATTERN        = LOGFILE_PATTERN_ARRAY[ MLIST ]

}

# ============================================================================
# === BEGIN-Block fuer Test-Einstellungen ====================================
# ============================================================================

BEGIN {
#---------------------------
   DEBUG   = "OFF"
#---------------------------
}

# ============================================================================
# === BEGIN-Block fuer die Eingabedateien ====================================
# ============================================================================

BEGIN {
   SCRATCH_FILE = "scratch.tmp"

   if ( FROM == "" || TO == "" )
   {  while( ( getline line < SCRATCH_FILE ) > 0 )
      {  gsub( " ", "", line )
         if ( line ~ LOGFILE_PATTERN ) ARGV[ ARGC++ ] = ROOT "/data/" line
      }
      close( SCRATCH_FILE )
   }
   else
   {  year_s = substr( FROM, 1, 2 )  * 1
      month_s = substr( FROM, 3, 2 ) * 1
      year_e = substr( TO, 1, 2 )    * 1
      month_e = substr( TO, 3, 2 )   * 1

      if ( year_s == year_e )
      {  for( m=month_s; m<=month_e; m++ )
         {  ARGV[ ARGC ] = ROOT "/data/" sprintf( "%02d%02d", year_s, m )
            ARGC++
         }
      }
      else
      {  for( m=month_s; m<=12; m++ )
         {  ARGV[ ARGC ] = ROOT "/data/" sprintf( "%02d%02d", year_s, m )
            ARGC++
         }
         if ( year_s < year_e - 1 )
         {  for( y = year_s + 1; y <= year_e - 1; y++ )
            {  for( m=1; m<=12; m++ )
               {  ARGV[ ARGC ] = ROOT "/data/" sprintf( "%02d%02d", y, m )
                  ARGC++
               }
            }
         }
         for( m=1; m<=month_e; m++ )
         {  ARGV[ ARGC ] = ROOT "/data/" sprintf( "%02d%02d", year_e, m )
            ARGC++
         }
      }
   }

   print  "\n"
   print  substr( dashes, 1, 78 )				> STDERR
   printf "Bearbeitete Mailingliste: %s // ", MLIST		> STDERR
   printf "Root-Verzeichnis: %s\n", ROOT			> STDERR
   print  substr( dashes, 1, 78 )				> STDERR
}

# ============================================================================
# === BEGIN-Block fuer Update-Informationen ==================================
# ============================================================================

BEGIN {
   if ( BASIS == 0 )
   {  GLOBAL_MAILNO = 0
   }
   else
   {  DB_BASIS = ROOT "/" BASIS "/mail.dbc"
      i = getline line 						< DB_BASIS
      while( i > 0 )
      {  i = getline line					< DB_BASIS
      }
      split( line, dummy, ";" )
      GLOBAL_MAILNO = dummy[3]
      print "Start bei Mail-Number #" GLOBAL_MAILNO+1		> STDERR
   }
}

# ============================================================================
# === BEGIN-Block fuer allgemeine Einstellungen ==============================
# ============================================================================

BEGIN {

   DATE_FORMAT[1]       = \
        "^[0-9]+ [A-Z][A-Z][A-Z] (19[89][0-9]|[89][0-9]) " \
             "[0-9]+:[0-5][0-9]"
   DATE_FORMAT[2]       = \
        "^[A-Z]+, [0-9]+ [A-Z][A-Z][A-Z] " \
             "(19[89][0-9]|[89][0-9]) [0-9]+:[0-5][0-9]"

   UUENCODE_TRIGGER     = "^begin [0-7][0-7][0-7] .*$"

   MONTHS_LIST          = ";JAN;FEB;MAR;APR;MAY;JUN;JUL;AUG;SEP;OCT;NOV;DEC"

   TO_GMT["CEST"]       =  -2
   TO_GMT["MEST"]       =  -2
   TO_GMT["MESZ"]       =  -2
   TO_GMT["EET"]        =  -2
   TO_GMT["CET"]        =  -1
   TO_GMT["MET"]        =  -1
   TO_GMT["MEZ"]        =  -1
   TO_GMT["BST"]        =  -1
   TO_GMT["UTC"]        =   0
   TO_GMT["GMT"]        =   0
   TO_GMT["WET"]        =   0
   TO_GMT["EDT"]        =   4
   TO_GMT["EST"]        =   5
   TO_GMT["CDT"]        =   5
   TO_GMT["CST"]        =   6
   TO_GMT["MDT"]        =   6
   TO_GMT["MST"]        =   7
   TO_GMT["PDT"]        =   7
   TO_GMT["PST"]        =   8

   TO_GMT["0000"]       =   0                          # --- silly formats ---
   TO_GMT["0100"]       =   1
   TO_GMT["0200"]       =   2
   TO_GMT["0300"]       =   3
   TO_GMT["0400"]       =   4
   TO_GMT["0500"]       =   5
   TO_GMT["0600"]       =   6
   TO_GMT["0700"]       =   7
   TO_GMT["0800"]       =   8
   TO_GMT["0900"]       =   9
   TO_GMT["1000"]       =  10
   TO_GMT["1100"]       =  11
   TO_GMT["1200"]       =  12
   TO_GMT["GMT+1"]      =  -1
   TO_GMT["GMT+2"]      =  -2
   TO_GMT["GMT+3"]      =  -3
   TO_GMT["GMT+4"]      =  -4
   TO_GMT["GMT+5"]      =  -5
   TO_GMT["GMT+6"]      =  -6
   TO_GMT["GMT+7"]      =  -7
   TO_GMT["GMT+8"]      =  -8
   TO_GMT["GMT+9"]      =  -9
   TO_GMT["GMT+10"]     = -10
   TO_GMT["GMT+11"]     = -11
   TO_GMT["GMT+12"]     = -12
   TO_GMT["GMT-1"]      =   1
   TO_GMT["GMT-2"]      =   2
   TO_GMT["GMT-3"]      =   3
   TO_GMT["GMT-4"]      =   4
   TO_GMT["GMT-5"]      =   5
   TO_GMT["GMT-6"]      =   6
   TO_GMT["GMT-7"]      =   7
   TO_GMT["GMT-8"]      =   8
   TO_GMT["GMT-9"]      =   9
   TO_GMT["GMT-10"]     =  10
   TO_GMT["GMT-11"]     =  11
   TO_GMT["GMT-12"]     =  12
   TO_GMT["+0000"]      =   0
   TO_GMT["+0100"]      =  -1
   TO_GMT["+0200"]      =  -2
   TO_GMT["+0300"]      =  -3
   TO_GMT["+0400"]      =  -4
   TO_GMT["+0500"]      =  -5
   TO_GMT["+0600"]      =  -6
   TO_GMT["+0700"]      =  -7
   TO_GMT["+0800"]      =  -8
   TO_GMT["+0900"]      =  -9
   TO_GMT["+1000"]      = -10
   TO_GMT["+1100"]      = -11
   TO_GMT["+1200"]      = -12
   TO_GMT["+1300"]      = -13
   TO_GMT["-0000"]      =   0
   TO_GMT["-0100"]      =   1
   TO_GMT["-0200"]      =   2
   TO_GMT["-0300"]      =   3
   TO_GMT["-0400"]      =   4
   TO_GMT["-0500"]      =   5
   TO_GMT["-0600"]      =   6
   TO_GMT["-0700"]      =   7
   TO_GMT["-0800"]      =   8
   TO_GMT["-0900"]      =   9
   TO_GMT["-1000"]      =  10
   TO_GMT["-1100"]      =  11
   TO_GMT["-1200"]      =  12
   TO_GMT["-1300"]      =  13
   TO_GMT[""]           =   0

   ISO_CS = "\a\b\t\n\v\f\r"  \
            " !\"#$%&'()*+,-./0123456789:;<=>?" \
            "@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_"  \
            "`abcdefghijklmnopqrstuvwxyz{|}~"  \
            ""  \
            " \"@İ-3',1" \
            "AAAAEEEIIIIDOOOOXOUUUY"  \
            "aooy"
   HEXTAB = "0123456789ABCDEF"

   DASHES               = "----------------------------------------" \
                          "----------------------------------------"
   STATE = "SKIP"
   OLD_LOG_DATE = "-1"
}

# ============================================================================
# === Functions ==============================================================
# ============================================================================

# ----------------------------------------------------------------------------
# --- Fehlermeldung ausgeben -------------------------------------------------
# ----------------------------------------------------------------------------

function error( error_msg ) {
   if ( DEBUG == "ON" ) printf "\n"
   printf "%s [%s # %d] STATE=%s\n...%s\n", \
          error_msg, filnam, FNR, STATE, $0
   if ( DEBUG == "ON" ) exit
}

# ----------------------------------------------------------------------------
# --- Neue Eingabedatei ------------------------------------------------------
# ----------------------------------------------------------------------------

function process_new_file(               l, i, c ) {
   STATE = "SKIP"
   INPUTFILE = FILENAME
   if ( index( FILENAME, "/" ) > 0 || index( FILENAME, "\\" ) > 0 )
   {  l = length( FILENAME )
      for( i=l; i>=1; i-- )
      {  c = substr( FILENAME, i, 1 )
         if ( c == "/" || c == "\\" ) break
      }
      filnam = substr( FILENAME, i+1 )
   }
   else
   {  filnam = FILENAME
   }
   LOCAL_MAILNO = 0
   print FILENAME, "***", GLOBAL_MAILNO+1, "***"		> STDERR
   xlen = length( FILENAME )
}

# ----------------------------------------------------------------------------
# --- Verwaltungsinformationen ausgeben --------------------------------------
# ----------------------------------------------------------------------------

function process_start_mail(             line ) {
   GLOBAL_MAILNO++
   LOCAL_MAILNO++
   line = sprintf( "--- %d;%s(%d);%d %s", \
                 GLOBAL_MAILNO, filnam, LOCAL_MAILNO, FNR, DASHES )
   print substr( line, 1, 78 )                                      > DB_FILE
   if (DEBUG == "ON" ) printf "."
   init()
}

# ----------------------------------------------------------------------------
# --- Extrahiere Absender-Daten ----------------------------------------------
# ----------------------------------------------------------------------------

function process_from_entry( from_text,            l, n, dummy, flag, i, j ) {
   if ( index( from_text, "=" ) > 0 ) from_text = unquote( from_text )
   l = index( from_text, ":" )
   from_text = substr( from_text, l+1 )
#  gsub( "[^ !#$%&'*+,-./:;=?^_0-9@A-Za-zA]", " ", from_text )
   gsub( "[^ !#$%&'*+,-./:;=?^_0-9@A-ZA]", " ", from_text )
   gsub( ";", ",", from_text )
   gsub( " +", " ", from_text )

   n = split( from_text, dummy, " " )

   flag = "*"
   for( i=1; i<=n; i++ )
   {  if ( index( dummy[i], "@" ) > 0 )
      {  flag = " "
         break
      }
   }
   if ( flag == " " ) addr_str = dummy[i]
   else               addr_str = ""

   name_str = ""
   for( j=1; j<=n; j++ )
   {  if ( j != i && dummy[j] != "" ) name_str = name_str " " dummy[j]
   }
   if ( substr( name_str, 1, 1 ) == " " ) name_str = substr( name_str, 2 )
   if ( index( name_str, "@" ) > 0 )
   {  if ( length(name_str) > length(addr_str) )
      {  scratch = addr_str
         addr_str = name_str
         name_str = scratch
      }
   }
   if ( name_str ~ "^ *$" ) name_str = "<" addr_str ">"
 
   FROM_DATA[1] = addr_str
   FROM_DATA[2] = name_str
}

# ----------------------------------------------------------------------------
# --- Extrahiere Betreff-Informationen ---------------------------------------
# ----------------------------------------------------------------------------

function process_subj_entry( subj_text,            l, l1, l2 ) {
   if ( IGNORE_TEXT_IN_SUBJECT != "" ) \
      gsub( IGNORE_TEXT_IN_SUBJECT, "", subj_text )
   subj_text = unquote( subj_text )
   l = index( subj_text, ":" )
   subj_text = substr( subj_text, l+1 )
   gsub( "\"", "'", subj_text )
   gsub( ";", "," subj_text )
   gsub( "\t", " ", subj_text )
   gsub( " +", " ", subj_text )
   gsub( "\\( WAS", "(WAS", subj_text )
   gsub( "RE\\[[0-9]+\\]", "RE", subj_text )
   gsub( "RE\\^[0-9]+", "RE", subj_text )
   gsub( "RE\\*[0-9]+", "RE", subj_text )

   was_text = ""
   l1 = index( subj_text, "WAS:" )
   l2 = index( subj_text, "(WAS" )
   l = ( l1 > l2 ) ? l1 : l2
   if ( l > 0 )
   {  was_text = substr( subj_text, l+4 )
      subj_text = substr( subj_text, 1, l-1 )
   }
   else
   {  l = index( subj_text, "WAS RE:" )
      if ( l > 0 )
      {  was_text = substr( subj_text, l+4 )
         subj_text = substr( subj_text, 1, l-1 )
      }
   }

   gsub( "^ ", "", subj_text )
   gsub( "\\($", "", subj_text )
   gsub( " $", "", subj_text )
   gsub( "^ ", "", was_text )
   gsub( "\\)$", "", was_text )
   gsub( " $", "", was_text )

   reply_flag = 0
   if ( substr( subj_text, 1, 3 ) == "RE:" )
   {  subj_text = substr( subj_text, 4 )
      gsub( "^ ", "", subj_text )
      reply_flag = 1
   }

   if ( index( subj_text, " -REPLY" ) > 0 )
   {  gsub( " *-REPLY *", "", subj_text )
      reply_flag = 3
   }

   if ( index( subj_text, "RCPT:" ) > 0 )
   {  gsub( " *RCPT: *", "", subj_text )
      reply_flag = 5
   }
   while( subj_text ~ "^ *RE\:.*$" ) gsub( "^ *RE\: *", "", subj_text )

   if ( was_text != "" )
   {  if ( substr( was_text, 1, 3 ) == "RE:" )
      {  was_text = substr( was_text, 4 )
         gsub( "^ ", "", was_text )
         reply_flag = 2
      }
   }

   if ( index( was_text, " -REPLY" ) > 0 )
   {  gsub( " -REPLY", "", was_text )
      reply_flag = 4
   }

   SUBJ_DATA[1] = reply_flag
   SUBJ_DATA[2] = subj_text
   SUBJ_DATA[3] = was_text
}

# ----------------------------------------------------------------------------
# --- Extrahiere Datum/Uhrzeit -----------------------------------------------
# ----------------------------------------------------------------------------

function process_date_entry( date_text,            l, n, dummy1, dummy2, t, \
                                                   day, month, year, JD,    \
                                                   timezone,                \
                                                   hours, minutes, seconds, \
                                                   SEC, date_str, time_str ) {
   l = index( date_text, ":" )
   date_text = substr( date_text, l+1 )
   gsub( "\t", " ", date_text )
   gsub( " +", " ", date_text )
   gsub( "^ ", "", date_text )
   DATE_ERROR = 0
   if ( ! ( date_text ~ DATE_FORMAT[1] || \
            date_text ~ DATE_FORMAT[2]       ) )
   {  DATE_DATA[1] = date_text
      DATE_DATA[3] = "-1"
      return
   }

   gsub( "GMT +\\+", "GMT+", date_text )
   gsub( "GMT +\\-", "GMT-", date_text )

   n = split( date_text, dummy1, " " )
   if ( date_text ~ DATE_FORMAT[1] )
   {  day = dummy1[1]
      month = month2num( dummy1[2] )
      year = dummy1[3]
      split( dummy1[4], dummy2, ":" )
      timezone = dummy1[5]
   }
   if ( date_text ~ DATE_FORMAT[2] )
   {  day = dummy1[2]
      month = month2num( dummy1[3] )
      year = dummy1[4]
      split( dummy1[5], dummy2, ":" )
      timezone = dummy1[6]
   }

   gsub( "\\+\\-", "-", timezone )
   gsub( "\\-\\-", "+", timezone )
   gsub( "\\+\\+", "+", timezone )
   if ( timezone ~ "^[+-][0-9]$" )

   {  timezone = substr( timezone, 1, 1 ) "0" substr( timezone, 2 ) "00"
   }
   if ( timezone ~ "^[+-][0-9][0-9][0-9]$" )
   {  timezone = substr( timezone, 1, 1 ) "0" substr( timezone, 2 )
   }

   if ( month == 0 )
   {  DATE_DATA[1] = date_text
      DATE_DATA[3] = "-1"
      return
   }
   if ( ! ( timezone in TO_GMT ) )
   {  DATE_DATA[1] = date_text
      if ( year < 100 ) year += 1900
      JD = julday( day, month, year )
      DATE_DATA[3] = JD ".43200"
      return
   }

   if ( year < 100 ) year += 1900
   JD = julday( day, month, year )
   hours = dummy2[1]
   minutes = dummy2[2]
   seconds = 0
   if ( dummy2[3] ~ "^[0-5][0-9]" ) seconds = substr( dummy2[3], 1, 2 )
   SEC = secpmn( hours, minutes, seconds )

   date_str = sprintf( "%02d-%02d-%04d", day, month, year )
   time_str = sprintf( "%02d:%02d:%02d %s", \
                       hours, minutes, seconds, timezone )

   if ( timezone != "GMT" )
   {  t = SEC + TO_GMT[timezone] * 3600
      time_str = s2time( t ) " GMT"
      date_str = jdate( JD )
      if ( t < 0 )
      {  JD--
         SEC = SEC + 86400 + TO_GMT[timezone] * 3600
         date_str = jdate( JD )
         time_str = s2time( SEC ) " GMT"
      }
      if ( t >= 86400 )
      {  JD++
         SEC = SEC - 86400 + TO_GMT[timezone] * 3600
         date_str = jdate( JD )
         time_str = s2time( SEC ) " GMT"
      }
   }
   DATE_DATA[1] = date_text
   DATE_DATA[2] = date_str " " time_str
   DATE_DATA[3] = JD "." sprintf( "%05d", SEC )
}

# ----------------------------------------------------------------------------
# --- Verarbeite den Nachrichtenkopf -----------------------------------------
# ----------------------------------------------------------------------------

function process_header(                 scratch ) {
   process_from_entry( FROM )
   print "F|" FROM_DATA[1] ";" FROM_DATA[2]                          > DB_FILE

   process_subj_entry( SUBJ )
   print "S|" SUBJ_DATA[1] ";" SUBJ_DATA[2] ";" SUBJ_DATA[3]         > DB_FILE

   process_date_entry( DATE )
   scratch = "D"
   if ( DATE_DATA[2] == "" )
   {  scratch = "d"
      DATE_DATA[2] = DATE_DATA[1]
   }
   print scratch "|" DATE_DATA[1] ";" DATE_DATA[2] 		     > DB_FILE

   scratch = FROM_DATA[1] ";" FROM_DATA[2]
   if ( !( scratch in USER_ARRAY ) )
   {  N_OF_USER++
      USER_ARRAY[ scratch ] = N_OF_USER
   }

   if ( !( SUBJ_DATA[2] in SUBJ_ARRAY ) )
   {  N_OF_SUBJ++
      SUBJ_ARRAY[ SUBJ_DATA[2] ] = N_OF_SUBJ
   }
   printf "%d;%s;%s;%s\n", \
                  SUBJ_ARRAY[ SUBJ_DATA[2] ]*10, GLOBAL_MAILNO,
                  SUBJ_DATA[2], DATE_DATA[2]                       > SUBJ_FILE
}

# ----------------------------------------------------------------------------
# --- Wandle quoted printables um --------------------------------------------
# ----------------------------------------------------------------------------

function unquote( line,                  qline, uqline, n1, n2 ) {
   qline = line
   uqline = line
   i = match( qline, "=[0-9A-F][0-9A-F]" )
   while( i > 0 ) {
      n1 = index( HEXTAB, substr( qline, i+1, 1 ) ) - 1
      n2 = index( HEXTAB, substr( qline, i+2, 1 ) ) - 1
      uqline = substr( qline, 1, i-1 ) substr( ISO_CS, n1*16+n2+1, 1 ) \
               substr( qline, i+3 )
      qline = uqline
      i = match( qline, "=[0-9A-F][0-9A-F]" )
   }
   sub( "=\\?ISO-8859-1\\?Q\\?", "", uqline )
   sub( "?=", "", uqline )
   if ( match( uqline, "[]" ) > 0 )
   {  gsub( "", "", uqline )
      gsub( "", "", uqline )
      gsub( "", "", uqline )
      gsub( "", "", uqline )
      gsub( "", "", uqline )
      gsub( "", "", uqline )
      gsub( "", "", uqline )
   }
#  if ( match( uqline, "[\{\|\}\[\\\]\~]" ) > 0 )
#  {  gsub( "{", "", uqline )
#     gsub( "|", "", uqline )
#     gsub( "}", "", uqline )
#     gsub( "[", "", uqline )
#     gsub( "\", "", uqline )
#     gsub( "]", "", uqline )
#     gsub( "~", "", uqline )
#  }
   if ( match( uqline, "[]" ) > 0 )
   {  gsub( "", "AE", uqline )
      gsub( "", "OE", uqline )
      gsub( "", "UE", uqline )
      gsub( "", "AE", uqline )
      gsub( "", "OE", uqline )
      gsub( "", "UE", uqline )
      gsub( "", "SS", uqline )
   }
   return uqline
}

# ----------------------------------------------------------------------------
# --- Reset ------------------------------------------------------------------
# ----------------------------------------------------------------------------

function init() {
   FROM = ""
   SUBJ = ""
   DATE = ""
   FROM_DATA[1] = ""
   FROM_DATA[2] = ""
   SUBJ_DATA[1] = ""
   SUBJ_DATA[2] = ""
   SUBJ_DATA[3] = ""
   DATE_DATA[1] = ""
   DATE_DATA[2] = ""
   DATE_DATA[3] = ""
}

# ----------------------------------------------------------------------------
# --- Konversion eines gregorianischen Kalenderdatums in den entsprechenden
# --- Julianischen Tag.
# ----------------------------------------------------------------------------

function julday( DD, MM, YY,                       C, YA ) {
   if ( MM > 2 )
   {  MM = MM - 3
   }
   else
   {  MM = MM + 9
      YY = YY - 1
   }
   C = int( YY / 100 )
   YA = YY - 100 * C
   JULDAY =  int( ( 146097 * C ) / 4 ) + int( ( 1461 * YA ) / 4 )
   JULDAY += int( ( 153 * MM + 2 ) / 5 ) + DD + 1721119
   return JULDAY
}

# ----------------------------------------------------------------------------
# --- jdate konvertiert den Julianischen Tag JULDAY in das zugehoerige
# --- gregorianische Datum (Format: DD-MM-YYYY).
# ----------------------------------------------------------------------------

function jdate( JULDAY,                            YY, DD, MM ) {
   JULDAY = JULDAY - 1721119
   YY = int( ( 4 * JULDAY - 1 ) / 146097 )
   JULDAY = 4 * JULDAY - 1 - 146097 * YY
   DD = int( JULDAY / 4 )
   JULDAY = int( ( 4 * DD + 3 ) / 1461 )
   DD = 4 * DD + 3 - 1461 * JULDAY
   DD = int( ( DD + 4 ) / 4 )
   MM = int( ( 5 * DD - 3 ) / 153 )
   DD = 5 * DD - 3 - 153 * MM
   DD = int( ( DD + 5 ) / 5 )
   YY = 100 * YY + JULDAY
   if ( MM < 10 )
   {  MM = MM + 3
   }
   else
   {  MM = MM - 9
      YY = YY + 1
   }
   return sprintf( "%02d-%02d-%04d", DD, MM, YY )
}

# ----------------------------------------------------------------------------
# --- Anzahl der Sekunden nach Mitternacht -----------------------------------
# ----------------------------------------------------------------------------

function secpmn( HH, MMM, SS ) {
   return ( ( HH * 60 ) + MMM ) * 60 + SS
}

# ----------------------------------------------------------------------------
# --- Konversion eines Monatsnamens in die Monatsnummer ----------------------
# ----------------------------------------------------------------------------

function month2num( month_name,                    LL ) {
   LL = index( MONTHS_LIST, ";" month_name )
   if ( LL == 0 ) return LL
   return ( ( LL - 1) / 4 ) + 1
}

# ----------------------------------------------------------------------------
# --- Konversion des Sekunden nach Mitternacht in eine uebliche Zeitangabe ---
# ----------------------------------------------------------------------------

function s2time( time,                             hh, xx, mm, ss ) {
   hh = int( time/ 3600 )
   xx = time - hh * 3600
   mm = int( xx / 60 )
   ss = xx - mm * 60
   return sprintf( "%02d:%02d:%02d", hh, mm, ss )
}

# ============================================================================
# === Eingabe-Schleife =======================================================
# ----------------------------------------------------------------------------
# Finite State Machine. States:	SKIP
#				HEADER
#				BODY
# ============================================================================

{
   if ( NR == 1 ) init()
   if ( INPUTFILE != FILENAME ) process_new_file()

# ----------------------------------------------------------------------------

   if ( STATE == "SKIP" )
   {  if ( $0 ~ START_MAIL_TRIGGER )
      {  process_start_mail()
         STATE = "HEADER"
      }
      next
   }

# ----------------------------------------------------------------------------

   if ( STATE == "HEADER" )
   {  if ( $0 ~ END_HEADER_TRIGGER )
      {  process_header()
         if ( OLD_LOG_DATE == "-1" )
         {  OLD_LOG_DATE = DATE_DATA[3]
         }
         else
         {  if ( DATE_DATA[3] != "-1" && LOG_DIFF_DATE != "-1" )
            LOG_DATE_DIFF = DATE_DATA[3] - OLD_LOG_DATE
            if ( LOG_DATE_DIFF < -35 || LOG_DATE_DIFF > 35 )
            {  print "*** Verdaechtiges Datum: <<<" DATE_DATA[1] ">>>" > STDERR
               print "    in " filnam " # " GLOBAL_MAILNO " , Diff: " \
                     LOG_DATE_DIFF > STDERR
               if ( LOG_DATE_DIFF > 0 && LOG_DATE_DIFF < 60 )
	       {  OLD_LOG_DATE = DATE_DATA[3]
                  print "    ... recovering ..." > STDERR
               }
            }
            else
            {  OLD_LOG_DATE = DATE_DATA[3]
            }
         }
         STATE = "BODY"
         next
      }
      TEXT = toupper( $0 )
      gsub( ";", ",", TEXT )
      if ( TEXT ~ FROM_TRIGGER ) FROM = TEXT
      if ( TEXT ~ SUBJ_TRIGGER ) SUBJ = TEXT
      if ( TEXT ~ DATE_TRIGGER ) DATE = TEXT
      next
   }

# ----------------------------------------------------------------------------

   if ( STATE == "BODY" )
   {  if ( $0 ~ START_MAIL_TRIGGER )
      {  process_start_mail()
         STATE = "HEADER"
         next
      }
      next
   }
}

END {
   print substr( "END " dashes, 1, xlen ) " ***",\
         GLOBAL_MAILNO, "***"  					  > STDERR

   for( user in USER_ARRAY )
   {  split( user, dummy, ";" )
      n = split( dummy[2], scr, " " )
      printf "%d;%s;%s\n",  USER_ARRAY[ user ], user, scr[n]      > USER_FILE
   }
}
