##############################################################################
# PHASE-2.AWK                                          		 26-04-98 (ra)
# ----------------------------------------------------------------------------
# Das Programm PHASE-2.AWK dient der Erzeugung von Netzwerkdaten auf der Basis
# der automatisch erzeugten Headerdaten und der manuell aufbereiteten Thread-
# und Userdaten.
# ----------------------------------------------------------------------------
##############################################################################

BEGIN {
   FULLMATRIX = 0			# = 1 : fullmatrix  ,  = 0 : edgelist
}
 
BEGIN {
   # -------------------------------------------------------------------------
   # --- Einlesen von Konstanten ---------------------------------------------
   # -------------------------------------------------------------------------

   # --- Root ----------------------------------------------------------------

   ROOT = ENVIRON[ "ROOT" ]
   gsub( "\\\\", "/", ROOT )

   # --- Datei-Namen ---------------------------------------------------------

   STDERR    = "/dev/stderr"

   MAILDB    = ROOT "/tables/mail.db"		# Headerdaten
   ADDR_TAB  = ROOT "/tables/addr.tab"		# Adressdaten

   USER_LST  = "user.lst"			# halbautom. erz. Userdaten
   THRD_LST  = "thrd.lst"			# halbautom. erz. Threaddaten

   USER_TAB  = "user.tab"			# user.tab
   USER_TABX = "user.tabx"			# user.tabx
   THRD_TAB  = "thread.tab"			# thread.tab
   THRD_TABX = "thread.tabx"			# thread.tabx
   MAILDB_C  = "mail.dbc"			# mail.dbc
   DL_FILE   = "thrd_net.dl"			# thrd_net.dl
   DL_FILE1  = "resp_net.dl"
   GRP_FILE  = "group.tab"			# dummy

   ARGV[ ARGC++ ] = MAILDB

   # -------------------------------------------------------------------------

   dashes = "------------------------------------"
   dashes = dashes "------------------------------------"
}

BEGIN {
   # -------------------------------------------------------------------------
   # --- Einlesen und Verarbeiten der THREAD-Codes ---------------------------
   # -------------------------------------------------------------------------

   i = getline line						< THRD_LST
   while( i > 0 )
   {  split( line, dummy, ";" )
      code = dummy[1]*1
      mid  = dummy[2]
      subj = dummy[3]
      date = dummy[4]
      if ( !( code in new_code ) )
      {  nc++
         new_code[ code ] = nc
      }
      nn = new_code[ code ]

      N_OF_THREADS = N_OF_THREADS > nn ? N_OF_THREADS : nn
      THRD_ID[ subj ";" date ] = nn

      if ( MLIST[ nn ] == "" )
      {  MLIST[ nn ] = dummy[2]
      }
      else
      {  jj = split( MLIST[ nn ], dummy, ";" )
         found = 0
         for( j=1; j<=jj; j++ )
         {  if ( dummy[j] == mid )
            {  found = 1
               break
            }
         }
         if ( found == 0 ) MLIST[ nn ] = MLIST[ nn ] ";" mid
      }
      i = getline line						< THRD_LST
   }
   close( THRD_LST )

   nc = 0
   for( n in new_code ) delete new_code[ n ]

   print "THREAD_LIST verarbeitet"				> STDERR
}

BEGIN {
   # -------------------------------------------------------------------------
   # --- Einlesen der Adressdaten --------------------------------------------
   # -------------------------------------------------------------------------

   i = getline line						< ADDR_TAB
   while( i > 0 )
   {  split( line, dummy, ";" )
      ADDR_CODE[ toupper( dummy[2] ) ] = dummy[1]
      i = getline line						< ADDR_TAB
   }
   close( ADDR_TAB )

   print "ADDRESS_TAB verarbeitet"				> STDERR
}

BEGIN {
   # -------------------------------------------------------------------------
   # --- Einlesen und Verarbeiten der USER-Codes -----------------------------
   # -------------------------------------------------------------------------

   i = getline line						< USER_LST
   while( i > 0 )
   {  split( line, dummy, ";" )
      code = dummy[1]*1
      addr = dummy[2]
      name = dummy[3]
      if ( !( code in new_code ) )
      {  nc++
         new_code[ code ] = nc
      }
      nn = new_code[ code ]

      N_OF_USERS = N_OF_USERS > nn ? N_OF_USERS : nn
      USER_ID[ addr ";" name ] = nn

      ADDR[ nn ] = addr
      if ( index( name, "@" ) > 0 ) name = ""

      if ( ALIST[ nn ] == "" )
      {  ALIST[ nn ] = ADDR_CODE[ addr ]
         NAME[ nn ] = name
      }
      else
      {  jj = split( ALIST[ nn ], dummy, ";" )
         found = 0
         for( j=1; j<=jj; j++ )
         {  if ( dummy[j] == ADDR_CODE[ addr ] )
            {  found = 1
               break
            }
         }
         if ( found == 0 ) ALIST[ nn ] = ALIST[ nn ] ";" ADDR_CODE[ addr ]
         NAME[ nn ] = length( NAME[nn] ) > length( name ) ? NAME[nn] : name
      }
      i = getline line						< USER_LST
   }
   close( USER_LST )

   nc = 0
   for( n in new_code ) delete new_code[ n ]

   for( i=1; i<=N_OF_USERS; i++ )
   {  if ( NAME[i]  == "" ) NAME[i]  = "<" ADDR[i] ">"
      if ( ALIST[i] == "" ) ALIST[i] = -1
      print i ";" NAME[i] ";" ALIST[i]				> USER_TAB
      drop ADDR[i]
   }

   print "USER_LIST verarbeitet"				> STDERR
}

# ----------------------------------------------------------------------------
# ----------------------------------------------------------------------------

function flush(                      dummy, i, n, found ) {
   uid = USER_ID[ addr ";" name ]

   if ( USER_PERIOD[ uid ] == "" )
   {  USER_PERIOD[ uid ] = archive
   }
   else
   {  n = split( USER_PERIOD[ uid ], dummy, "," )
      found = 0
      for( i=1; i<=n; i++ )
      {  if ( dummy[i] == archive )
         {  found = 1
            break
         }
      }
      if ( found == 0 ) \
         USER_PERIOD[ uid ] = USER_PERIOD[ uid ] "," archive
   }

   # --- proc_flag=0 fuer Dubletten ------------------------------------------

   proc_flag = 1
   tid = THRD_ID[ subj ";" date ]
   if ( tid > 10000 )
   {  tid -= 10000
      proc_flag = 0
   }
   THRD_ID[ subj ";" date ] = tid + 10000

   if ( uid == "" )
   {  print "***"
      print "*** mid=" mid
      print "*** tid=" tid
      print "*** UserList=" THREAD_USER[ tid ]
   }
   
   if ( THREAD_USER[ tid ] == "" )
   {  THREAD_USER[ tid ] = uid
   }
   else
   {  n = split( THREAD_USER[ tid ], dummy, ";" )
      found = 0
      for( i=1; i<=n; i++ )
      {  if ( dummy[i] == uid )
         {  found = 1
            break
         }
      }
      if ( found == 0 ) \
      THREAD_USER[ tid ] = THREAD_USER[ tid ] ";" uid
   }
   
   if ( THREAD_PERIOD[ tid ] == "" )
   {  THREAD_PERIOD[ tid ] = archive 
   }
   else
   {  n = split( THREAD_PERIOD[ tid ], dummy, ";" )
      found = 0
      for( i=1; i<=n; i++ )
      {  if ( dummy[i] == archive )
         {  found = 1
            break
         }
      }
      if ( found == 0 ) \
      THREAD_PERIOD[ tid ] = THREAD_PERIOD[ tid ] ";" archive
   }

   aid = ADDR_CODE[ addr ]

   print proc_flag ";" archive ";" mid ";" uid ";" aid ";" \
         tid ";" reply_flag ";" ds ";" date 			> MAILDB_C
   printf "."							> STDERR
}

# ----------------------------------------------------------------------------
# ----------------------------------------------------------------------------

/^-/	{  if ( NR > 1 ) flush()
           split( $0, dummy, " " )
           mid = dummy[2]
           split( mid, dummy, ";" )
           mid = dummy[1]
           archive = dummy[2]
           split( archive, dummy, "(" )
           archive = dummy[1]
	   n = split( archive, dummy, "." )
	   archive = substr( dummy[n], 4 )
        }

/^F/    {  split( substr( $0, 3 ), dummy, ";" )
           addr = dummy[1]
           name = dummy[2]
        }

/^[dD]/ {  split( substr( $0, 3 ), dummy, ";" )
           date = dummy[2]
	   ds = substr( $0, 1, 1 )
        }

/^S/    {  split( substr( $0, 3 ), dummy, ";" )
           reply_flag = dummy[1]
           subj = dummy[2]
        }

END {
   flush()
   printf "\nMAIL_DB verarbeitet\n"				> STDERR
}

END {
   for( i=1; i<=N_OF_USERS; i++ )
   {  print i ";" NAME[i] ";" ALIST[i] ";(" USER_PERIOD[i] ")"	> USER_TABX
   }
  
   for( i=1; i<=N_OF_THREADS; i++ )
   {  print i ";M;" MLIST[ i ]					> THRD_TAB
      print i ";U;" THREAD_USER[ i ]				> THRD_TAB
      print i ";M;" MLIST[ i ]					> THRD_TABX
      print i ";U;" THREAD_USER[ i ]				> THRD_TABX
      print i ";P;" THREAD_PERIOD[ i ]				> THRD_TABX
   }
   print "THREAD_TAB erstellt"					> STDERR
}

END {
   for( k=1; k<=N_OF_THREADS; k++ )
   {  n = split( THREAD_USER[k], dummy, ";" )
      if ( n == 1 ) continue
      for( i = 1; i <= n-1; i++ )
      {  for( j = i+1; j <= n; j++ )
         {  ij = dummy[i] ";" dummy[j]
            ji = dummy[j] ";" dummy[i]
            ARRAY[ ij ]++
            ARRAY[ ji ]++
         }
      }
      # --- j antwortet i ---------------------------------------
      init = dummy[1]
      for( i = 2; i <= n; i++ ) RESP_ARRAY[ dummy[i] ";" init ]++
      # ---------------------------------------------------------
   }
   print "Netzwerk-Matrix erstellt"				> STDERR
 
   if ( FULLMATRIX == 1 )
   {  print "dl n=" N_OF_USERS ", nm=1"				> DL_FILE
      print "format = fullmatrix"				> DL_FILE
      print "data:"                                             > DL_FILE
      for( i = 1; i <= N_OF_USERS; i++ )
      {  for( j = 1; j <= N_OF_USERS; j++ )
 	 {  if ( ! ( i ";" j in ARRAY ) ) \
	       printf "   0"					> DL_FILE
            else                          \
	       printf "%4d", ARRAY[ i ";" j ]			> DL_FILE
         }
         printf "\n"                                            > DL_FILE
      }
      print "dl n=" N_OF_USERS ", nm=1"				> DL_FILE1
      print "format = fullmatrix"				> DL_FILE1
      print "data:"                                             > DL_FILE1
      for( i = 1; i <= N_OF_USERS; i++ )
      {  for( j = 1; j <= N_OF_USERS; j++ )
 	 {  if ( ! ( i ";" j in RESP_ARRAY ) ) \
	       printf "   0"					> DL_FILE1
            else                          \
	       printf "%4d", RESP_ARRAY[ i ";" j ]		> DL_FILE1
         }
         printf "\n"                                            > DL_FILE1
      }
   }

   else

   {  print "dl n=" N_OF_USERS ", nm=1"				> DL_FILE
      print "format = edgelist1"				> DL_FILE
      print "data:"                                             > DL_FILE
      for( item in ARRAY )
      {  split( item, dummy, ";" )
	 print dummy[1], dummy[2], ARRAY[ item ]		> DL_FILE     
      }
      print "dl n=" N_OF_USERS ", nm=1"				> DL_FILE1
      print "format = edgelist1"				> DL_FILE1
      print "data:"                                             > DL_FILE1
      for( item in RESP_ARRAY )
      {  split( item, dummy, ";" )
	 print dummy[1], dummy[2], RESP_ARRAY[ item ]		> DL_FILE1    
      }
   }
 
   printf "1:"							> GRP_FILE
   for( i=1; i<N_OF_USERS; i++ ) printf "%d ", i		> GRP_FILE
   printf "%d\n", N_OF_USERS					> GRP_FILE
 
   print "Netzwerk-Daten ausgegeben"				> STDERR
}
